<?php
/**
 * apConnectionPoliciesActions
 * 
 * Implement the actions for the connection policies module
 * 
 * 
 * @package    authpuppy
 * @subpackage plugin
 * @author     Geneviève Bastien <gbastien@versatic.net>
 * @version    BZR: $Id$
 */

class apConnectionPoliciesActions extends apActions
{
  public function executeIndex(sfWebRequest $request)
  {
    $this->policies = Doctrine::getTable('apConnectionPolicies')
      ->createQuery('a')
      ->execute(); 
  }

  public function executeNew(sfWebRequest $request)
  {
    $this->form = new apConnectionPoliciesForm();
  }

  public function executeCreate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod(sfRequest::POST));

    $this->form = new apConnectionPoliciesForm();

    $this->processForm($request, $this->form);

    $this->setTemplate('new');
  }

  public function executeEdit(sfWebRequest $request)
  {
    $this->forward404Unless($policy = Doctrine::getTable('apConnectionPolicies')->find(array($request->getParameter('id'))), sprintf('Object policy does not exist (%s).', $request->getParameter('id')));
    $this->form = new apConnectionPoliciesForm($policy);
  }

  public function executeUpdate(sfWebRequest $request)
  {
    $this->forward404Unless($request->isMethod(sfRequest::POST) || $request->isMethod(sfRequest::PUT));
    $this->forward404Unless($policy = Doctrine::getTable('apConnectionPolicies')->find(array($request->getParameter('id'))), sprintf('Object policy does not exist (%s).', $request->getParameter('id')));
    $this->form = new apConnectionPoliciesForm($policy);

    $this->processForm($request, $this->form);

    $this->setTemplate('edit');
  }
  
  protected function processForm(sfWebRequest $request, sfForm $form)
  {
    $form->bind($request->getParameter($form->getName()), $request->getFiles($form->getName()));
    if ($form->isValid())
    {
      $policy = $form->save();

      $this->redirect('apConnectionPolicies/index');
    }
  }
  
  public function executeStatus(sfWebRequest $request) {
    // Use the current identity
    $identity = $this->getUser()->getAttribute('identity');
    
    if (!is_null($identity)) {
      $policies = Doctrine::getTable('apApplicablePolicies');
      $this->statuses = $policies->getForIdentity($identity);
    }
    else {
      $this->forward('node', 'login');
    }
  }
  
  
}